/**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package com.apileague;

import com.apileague.client.ApiInvoker;
import com.apileague.client.ApiException;
import com.apileague.client.Pair;

import com.apileague.client.model.*;

import java.util.*;

import com.android.volley.Response;
import com.android.volley.VolleyError;

import com.apileague.client.model.ComputeNutritionAPI200Response;
import com.apileague.client.model.RetrieveRecipeInformationAPI200Response;
import com.apileague.client.model.SearchDrinksAPI200Response;
import com.apileague.client.model.SearchRecipesAPI200Response;
import com.apileague.client.model.SearchRestaurantsAPI200Response;

import org.apache.http.HttpEntity;
import org.apache.http.entity.mime.MultipartEntityBuilder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeoutException;

public class FoodApi {
  String basePath = "https://api.apileague.com";
  ApiInvoker apiInvoker = ApiInvoker.getInstance();

  public void addHeader(String key, String value) {
    getInvoker().addDefaultHeader(key, value);
  }

  public ApiInvoker getInvoker() {
    return apiInvoker;
  }

  public void setBasePath(String basePath) {
    this.basePath = basePath;
  }

  public String getBasePath() {
    return basePath;
  }

  /**
  * Compute Nutrition API
  * Compute detailed nutritional information for a given recipe (list of ingredients). The API will return the nutritional information for each ingredient, as well as the total nutritional content for the entire recipe. Aside from macro and micro nutrients, the API also returns flavanoid information and food properties such as glycemic index, glycemic load, and inflammation score.
   * @param ingredients A comma-separated list of the ingredients of the recipe.
   * @param servings The number of servings the ingredients make. Nutrition is computed per serving.
   * @param reduceOils If there is oil in the ingredients, e.g. 3 tablespoons olive oil but they are used for frying, not all of the oil is consumed and therefore should not be added to the computed nutrition. In this case set reduce-oils to true.
   * @return ComputeNutritionAPI200Response
  */
  public ComputeNutritionAPI200Response computeNutritionAPI (String ingredients, Integer servings, Boolean reduceOils) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;
    // verify the required parameter 'ingredients' is set
    if (ingredients == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'ingredients' when calling computeNutritionAPI",
        new ApiException(400, "Missing the required parameter 'ingredients' when calling computeNutritionAPI"));
    }

    // create path and map variables
    String path = "/compute-nutrition";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    queryParams.addAll(ApiInvoker.parameterToPairs("", "ingredients", ingredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "servings", servings));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "reduce-oils", reduceOils));
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (ComputeNutritionAPI200Response) ApiInvoker.deserialize(localVarResponse, "", ComputeNutritionAPI200Response.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Compute Nutrition API
   * Compute detailed nutritional information for a given recipe (list of ingredients). The API will return the nutritional information for each ingredient, as well as the total nutritional content for the entire recipe. Aside from macro and micro nutrients, the API also returns flavanoid information and food properties such as glycemic index, glycemic load, and inflammation score.
   * @param ingredients A comma-separated list of the ingredients of the recipe.   * @param servings The number of servings the ingredients make. Nutrition is computed per serving.   * @param reduceOils If there is oil in the ingredients, e.g. 3 tablespoons olive oil but they are used for frying, not all of the oil is consumed and therefore should not be added to the computed nutrition. In this case set reduce-oils to true.
  */
  public void computeNutritionAPI (String ingredients, Integer servings, Boolean reduceOils, final Response.Listener<ComputeNutritionAPI200Response> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;

    // verify the required parameter 'ingredients' is set
    if (ingredients == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'ingredients' when calling computeNutritionAPI",
        new ApiException(400, "Missing the required parameter 'ingredients' when calling computeNutritionAPI"));
    }

    // create path and map variables
    String path = "/compute-nutrition".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();

    queryParams.addAll(ApiInvoker.parameterToPairs("", "ingredients", ingredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "servings", servings));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "reduce-oils", reduceOils));


    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((ComputeNutritionAPI200Response) ApiInvoker.deserialize(localVarResponse,  "", ComputeNutritionAPI200Response.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Retrieve Recipe Information API
  * Get detailed recipe information such as dietary properties, macro and micro nutrients, used ingredients and their amounts, and more.
   * @param id The id of the recipe to retrieve.
   * @param addWinePairing Whether to pair a wine to the recipe.
   * @return RetrieveRecipeInformationAPI200Response
  */
  public RetrieveRecipeInformationAPI200Response retrieveRecipeInformationAPI (Integer id, Boolean addWinePairing) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;
    // verify the required parameter 'id' is set
    if (id == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'id' when calling retrieveRecipeInformationAPI",
        new ApiException(400, "Missing the required parameter 'id' when calling retrieveRecipeInformationAPI"));
    }

    // create path and map variables
    String path = "/retrieve-recipe";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    queryParams.addAll(ApiInvoker.parameterToPairs("", "id", id));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "add-wine-pairing", addWinePairing));
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (RetrieveRecipeInformationAPI200Response) ApiInvoker.deserialize(localVarResponse, "", RetrieveRecipeInformationAPI200Response.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Retrieve Recipe Information API
   * Get detailed recipe information such as dietary properties, macro and micro nutrients, used ingredients and their amounts, and more.
   * @param id The id of the recipe to retrieve.   * @param addWinePairing Whether to pair a wine to the recipe.
  */
  public void retrieveRecipeInformationAPI (Integer id, Boolean addWinePairing, final Response.Listener<RetrieveRecipeInformationAPI200Response> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;

    // verify the required parameter 'id' is set
    if (id == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'id' when calling retrieveRecipeInformationAPI",
        new ApiException(400, "Missing the required parameter 'id' when calling retrieveRecipeInformationAPI"));
    }

    // create path and map variables
    String path = "/retrieve-recipe".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();

    queryParams.addAll(ApiInvoker.parameterToPairs("", "id", id));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "add-wine-pairing", addWinePairing));


    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((RetrieveRecipeInformationAPI200Response) ApiInvoker.deserialize(localVarResponse,  "", RetrieveRecipeInformationAPI200Response.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Search Drinks API
  * Search for drinks by title, ingredients, flavor, type of glass, alcohol content, and more.
   * @param query The search query.
   * @param glassTypes A comma-separated list (interpreted as OR) of glass types that the drink should be served in.
   * @param flavors A comma-separated list (interpreted as AND) of dominant flavors in the drink.
   * @param diet The diet the drink must adhere to. One of the following: paleo,primal,grain-free,vegan,vegetarian.
   * @param includeIngredients A comma-separated list of ingredients that should/must be used in the drinks.
   * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the drinks must not contain.
   * @param minCalories The minimum amount of calories the drink must have per serving.
   * @param maxCalories The maximum amount of calories the drink can have per serving.
   * @param minCarbs The minimum amount of carbohydrates in grams the drink must have per serving.
   * @param maxCarbs The maximum amount of carbohydrates in grams the drink can have per serving.
   * @param minProtein The minimum amount of protein in grams the drink must have per serving.
   * @param maxProtein The maximum amount of protein in grams the drink can have per serving.
   * @param minFat The minimum amount of fat in grams the drink must have per serving.
   * @param maxFat The maximum amount of fat in grams the drink can have per serving.
   * @param minAlcoholPercent The minimum alcohol percentage the drink must have.
   * @param maxAlcoholPercent The maximum alcohol percentage the drink can have.
   * @param minCaffeine The minimum amount of caffeine in milligrams the drink must have per serving.
   * @param maxCaffeine The maximum amount of caffeine in milligrams the drink can have per serving.
   * @param sort The attribute by which to sort the drinks.
   * @param sortDirection Whether to sort ascending or descending (ASC or DESC).
   * @param offset The number of drinks to skip, between 0 and 90.
   * @param number The number of drinks, between 1 and 10.
   * @return SearchDrinksAPI200Response
  */
  public SearchDrinksAPI200Response searchDrinksAPI (String query, String glassTypes, String flavors, String diet, String includeIngredients, String excludeIngredients, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minAlcoholPercent, Double maxAlcoholPercent, Double minCaffeine, Double maxCaffeine, String sort, String sortDirection, Integer offset, Integer number) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;

    // create path and map variables
    String path = "/search-drinks";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    queryParams.addAll(ApiInvoker.parameterToPairs("", "query", query));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "glass-types", glassTypes));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "flavors", flavors));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "diet", diet));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "include-ingredients", includeIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "exclude-ingredients", excludeIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-calories", minCalories));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-calories", maxCalories));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-carbs", minCarbs));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-carbs", maxCarbs));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-protein", minProtein));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-protein", maxProtein));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-fat", minFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-fat", maxFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-alcohol-percent", minAlcoholPercent));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-alcohol-percent", maxAlcoholPercent));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-caffeine", minCaffeine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-caffeine", maxCaffeine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort-direction", sortDirection));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "offset", offset));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "number", number));
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SearchDrinksAPI200Response) ApiInvoker.deserialize(localVarResponse, "", SearchDrinksAPI200Response.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Search Drinks API
   * Search for drinks by title, ingredients, flavor, type of glass, alcohol content, and more.
   * @param query The search query.   * @param glassTypes A comma-separated list (interpreted as OR) of glass types that the drink should be served in.   * @param flavors A comma-separated list (interpreted as AND) of dominant flavors in the drink.   * @param diet The diet the drink must adhere to. One of the following: paleo,primal,grain-free,vegan,vegetarian.   * @param includeIngredients A comma-separated list of ingredients that should/must be used in the drinks.   * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the drinks must not contain.   * @param minCalories The minimum amount of calories the drink must have per serving.   * @param maxCalories The maximum amount of calories the drink can have per serving.   * @param minCarbs The minimum amount of carbohydrates in grams the drink must have per serving.   * @param maxCarbs The maximum amount of carbohydrates in grams the drink can have per serving.   * @param minProtein The minimum amount of protein in grams the drink must have per serving.   * @param maxProtein The maximum amount of protein in grams the drink can have per serving.   * @param minFat The minimum amount of fat in grams the drink must have per serving.   * @param maxFat The maximum amount of fat in grams the drink can have per serving.   * @param minAlcoholPercent The minimum alcohol percentage the drink must have.   * @param maxAlcoholPercent The maximum alcohol percentage the drink can have.   * @param minCaffeine The minimum amount of caffeine in milligrams the drink must have per serving.   * @param maxCaffeine The maximum amount of caffeine in milligrams the drink can have per serving.   * @param sort The attribute by which to sort the drinks.   * @param sortDirection Whether to sort ascending or descending (ASC or DESC).   * @param offset The number of drinks to skip, between 0 and 90.   * @param number The number of drinks, between 1 and 10.
  */
  public void searchDrinksAPI (String query, String glassTypes, String flavors, String diet, String includeIngredients, String excludeIngredients, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minAlcoholPercent, Double maxAlcoholPercent, Double minCaffeine, Double maxCaffeine, String sort, String sortDirection, Integer offset, Integer number, final Response.Listener<SearchDrinksAPI200Response> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;


    // create path and map variables
    String path = "/search-drinks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();

    queryParams.addAll(ApiInvoker.parameterToPairs("", "query", query));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "glass-types", glassTypes));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "flavors", flavors));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "diet", diet));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "include-ingredients", includeIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "exclude-ingredients", excludeIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-calories", minCalories));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-calories", maxCalories));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-carbs", minCarbs));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-carbs", maxCarbs));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-protein", minProtein));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-protein", maxProtein));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-fat", minFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-fat", maxFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-alcohol-percent", minAlcoholPercent));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-alcohol-percent", maxAlcoholPercent));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-caffeine", minCaffeine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-caffeine", maxCaffeine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort-direction", sortDirection));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "offset", offset));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "number", number));


    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SearchDrinksAPI200Response) ApiInvoker.deserialize(localVarResponse,  "", SearchDrinksAPI200Response.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Search Recipes API
  * Search and filter thousands of recipes with natural language, e.g. pasta recipes without mushrooms but with truffles. You can filter by ingredients, diet, cuisine, meal type, macro and micro nutrition, intolerances, and much more.
   * @param query The search query.
   * @param cuisines The cuisine(s) of the recipes. One or more, comma-separated (will be interpreted as &#39;OR&#39;).
   * @param excludeCuisines The cuisine(s) the recipes must not match. One or more, comma-separated (will be interpreted as &#39;AND&#39;).
   * @param mealType The type of the recipe, one of: main course,side dish,dessert,appetizer,salad,bread,breakfast,soup,beverage,sauce,drink.
   * @param diet The diet the recipes must adhere to. One of the following: paleo,primal,grain-free,pescetarian,lacto vegetarian,ovo vegetarian,vegan,vegetarian.
   * @param intolerances A comma-separated list of intolerances. All recipes returned must not contain ingredients that are not suitable for people with the intolerances entered.
   * @param equipment The equipment required. Multiple values will be interpreted as &#39;OR&#39;.
   * @param includeIngredients A comma-separated list of ingredients that should/must be used in the recipes.
   * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the recipes must not contain.
   * @param fillIngredients Add information about the ingredients and whether they are used or missing in relation to the query.
   * @param addRecipeInformation If set to true, you get more information about the recipes returned.
   * @param maxTime The maximum time in minutes it should take to prepare and cook the recipe.
   * @param minServings The minimum amount of servings the recipe is for.
   * @param maxServings The maximum amount of servings the recipe is for.
   * @param minCalories The minimum amount of calories the recipe must have per serving.
   * @param maxCalories The maximum amount of calories the recipe can have per serving.
   * @param minCarbs The minimum amount of carbohydrates in grams the recipe must have per serving.
   * @param maxCarbs The maximum amount of carbohydrates in grams the recipe can have per serving.
   * @param minProtein The minimum amount of protein in grams the recipe must have per serving.
   * @param maxProtein The maximum amount of protein in grams the recipe can have per serving.
   * @param minFat The minimum amount of fat in grams the recipe must have per serving.
   * @param maxFat The maximum amount of fat in grams the recipe can have per serving.
   * @param minSugar The minimum amount of sugar in grams the recipe must have per serving.
   * @param maxSugar The maximum amount of sugar in grams the recipe can have per serving.
   * @param minFiber The minimum amount of fiber in grams the recipe must have per serving.
   * @param maxFiber The maximum amount of fiber in grams the recipe can have per serving.
   * @param minFolate The minimum amount of folate in micrograms the recipe must have per serving.
   * @param maxFolate The maximum amount of folate in micrograms the recipe can have per serving.
   * @param minFolicAcid The minimum amount of folic acid in micrograms the recipe must have per serving.
   * @param maxFolicAcid The maximum amount of folic acid in micrograms the recipe can have per serving.
   * @param minIodine The minimum amount of iodine in micrograms the recipe must have per serving.
   * @param maxIodine The maximum amount of iodine in micrograms the recipe can have per serving.
   * @param minIron The minimum amount of iron in milligrams the recipe must have per serving.
   * @param maxIron The maximum amount of iron in milligrams the recipe can have per serving.
   * @param minZinc The minimum amount of zinc in milligrams the recipe must have per serving.
   * @param maxZinc The maximum amount of zinc in milligrams the recipe can have per serving.
   * @param minMagnesium The minimum amount of magnesium in milligrams the recipe must have per serving.
   * @param maxMagnesium The maximum amount of magnesium in milligrams the recipe can have per serving.
   * @param minManganese The minimum amount of manganese in milligrams the recipe must have per serving.
   * @param maxManganese The maximum amount of manganese in milligrams the recipe can have per serving.
   * @param minPhosphorus The minimum amount of phosphorus in milligrams the recipe must have per serving.
   * @param maxPhosphorus The maximum amount of phosphorus in milligrams the recipe can have per serving.
   * @param minPotassium The minimum amount of potassium in milligrams the recipe must have per serving.
   * @param maxPotassium The maximum amount of potassium in milligrams the recipe can have per serving.
   * @param minSodium The minimum amount of sodium in milligrams the recipe must have per serving.
   * @param maxSodium The maximum amount of sodium in milligrams the recipe can have per serving.
   * @param minSelenium The minimum amount of selenium in micrograms the recipe must have per serving.
   * @param maxSelenium The maximum amount of selenium in micrograms the recipe can have per serving.
   * @param minCopper The minimum amount of copper in milligrams the recipe must have per serving.
   * @param maxCopper The maximum amount of copper in milligrams the recipe can have per serving.
   * @param minCalcium The minimum amount of calcium in milligrams the recipe must have per serving.
   * @param maxCalcium The maximum amount of calcium in milligrams the recipe can have per serving.
   * @param minCholine The minimum amount of choline in milligrams the recipe must have per serving.
   * @param maxCholine The maximum amount of choline in milligrams the recipe can have per serving.
   * @param minCholesterol The minimum amount of cholesterol in milligrams the recipe must have per serving.
   * @param maxCholesterol The maximum amount of cholesterol in milligrams the recipe can have per serving.
   * @param minFluoride The minimum amount of fluoride in milligrams the recipe must have per serving.
   * @param maxFluoride The maximum amount of fluoride in milligrams the recipe can have per serving.
   * @param minAlcohol The minimum amount of alcohol in grams the recipe must have per serving.
   * @param maxAlcohol The maximum amount of alcohol in grams the recipe can have per serving.
   * @param minCaffeine The minimum amount of caffeine in milligrams the recipe must have per serving.
   * @param maxCaffeine The maximum amount of caffeine in milligrams the recipe can have per serving.
   * @param minSaturatedFat The minimum amount of saturated fat in grams the recipe must have per serving.
   * @param maxSaturatedFat The maximum amount of saturated fat in grams the recipe can have per serving.
   * @param minVitaminA The minimum amount of Vitamin A in IU the recipe must have per serving.
   * @param maxVitaminA The maximum amount of Vitamin A in IU the recipe can have per serving.
   * @param minVitaminC The minimum amount of Vitamin C in milligrams the recipe must have per serving.
   * @param maxVitaminC The maximum amount of Vitamin C in milligrams the recipe can have per serving.
   * @param minVitaminD The minimum amount of Vitamin D in micrograms the recipe must have per serving.
   * @param maxVitaminD The maximum amount of Vitamin D in micrograms the recipe can have per serving.
   * @param minVitaminE The minimum amount of Vitamin E in milligrams the recipe must have per serving.
   * @param maxVitaminE The maximum amount of Vitamin E in milligrams the recipe can have per serving.
   * @param minVitaminK The minimum amount of Vitamin K in micrograms the recipe must have per serving.
   * @param maxVitaminK The maximum amount of Vitamin K in micrograms the recipe can have per serving.
   * @param minVitaminB1 The minimum amount of Vitamin B1 in milligrams the recipe must have per serving.
   * @param maxVitaminB1 The maximum amount of Vitamin B1 in milligrams the recipe can have per serving.
   * @param minVitaminB2 The minimum amount of Vitamin B2 in milligrams the recipe must have per serving.
   * @param maxVitaminB2 The maximum amount of Vitamin B2 in milligrams the recipe can have per serving.
   * @param minVitaminB3 The minimum amount of Vitamin B3 in milligrams the recipe must have per serving.
   * @param maxVitaminB3 The maximum amount of Vitamin B3 in milligrams the recipe can have per serving.
   * @param minVitaminB5 The minimum amount of Vitamin B5 in milligrams the recipe must have per serving.
   * @param maxVitaminB5 The maximum amount of Vitamin B5 in milligrams the recipe can have per serving.
   * @param minVitaminB6 The minimum amount of Vitamin B6 in milligrams the recipe must have per serving.
   * @param maxVitaminB6 The maximum amount of Vitamin B6 in milligrams the recipe can have per serving.
   * @param minVitaminB12 The minimum amount of Vitamin B12 in milligrams the recipe must have per serving.
   * @param maxVitaminB12 The maximum amount of Vitamin B12 in milligrams the recipe can have per serving.
   * @param sort The strategy to sort recipes by.
   * @param sortDirection Whether to sort ascending or descending (ASC or DESC).
   * @param offset The number of recipes to skip, between 0 and 900.
   * @param number The number of recipes, between 1 and 100.
   * @return SearchRecipesAPI200Response
  */
  public SearchRecipesAPI200Response searchRecipesAPI (String query, String cuisines, String excludeCuisines, String mealType, String diet, String intolerances, String equipment, String includeIngredients, String excludeIngredients, Boolean fillIngredients, Boolean addRecipeInformation, Integer maxTime, Integer minServings, Integer maxServings, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minSugar, Double maxSugar, Double minFiber, Double maxFiber, Double minFolate, Double maxFolate, Double minFolicAcid, Double maxFolicAcid, Double minIodine, Double maxIodine, Double minIron, Double maxIron, Double minZinc, Double maxZinc, Double minMagnesium, Double maxMagnesium, Double minManganese, Double maxManganese, Double minPhosphorus, Double maxPhosphorus, Double minPotassium, Double maxPotassium, Double minSodium, Double maxSodium, Double minSelenium, Double maxSelenium, Double minCopper, Double maxCopper, Double minCalcium, Double maxCalcium, Double minCholine, Double maxCholine, Double minCholesterol, Double maxCholesterol, Double minFluoride, Double maxFluoride, Double minAlcohol, Double maxAlcohol, Double minCaffeine, Double maxCaffeine, Double minSaturatedFat, Double maxSaturatedFat, Double minVitaminA, Double maxVitaminA, Double minVitaminC, Double maxVitaminC, Double minVitaminD, Double maxVitaminD, Double minVitaminE, Double maxVitaminE, Double minVitaminK, Double maxVitaminK, Double minVitaminB1, Double maxVitaminB1, Double minVitaminB2, Double maxVitaminB2, Double minVitaminB3, Double maxVitaminB3, Double minVitaminB5, Double maxVitaminB5, Double minVitaminB6, Double maxVitaminB6, Double minVitaminB12, Double maxVitaminB12, String sort, String sortDirection, Integer offset, Integer number) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;

    // create path and map variables
    String path = "/search-recipes";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    queryParams.addAll(ApiInvoker.parameterToPairs("", "query", query));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "cuisines", cuisines));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "exclude-cuisines", excludeCuisines));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "meal-type", mealType));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "diet", diet));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "intolerances", intolerances));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "equipment", equipment));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "include-ingredients", includeIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "exclude-ingredients", excludeIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "fill-ingredients", fillIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "add-recipe-information", addRecipeInformation));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-time", maxTime));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-servings", minServings));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-servings", maxServings));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-calories", minCalories));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-calories", maxCalories));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-carbs", minCarbs));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-carbs", maxCarbs));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-protein", minProtein));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-protein", maxProtein));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-fat", minFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-fat", maxFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-sugar", minSugar));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-sugar", maxSugar));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-fiber", minFiber));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-fiber", maxFiber));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-folate", minFolate));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-folate", maxFolate));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-folic-acid", minFolicAcid));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-folic-acid", maxFolicAcid));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-iodine", minIodine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-iodine", maxIodine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-iron", minIron));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-iron", maxIron));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-zinc", minZinc));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-zinc", maxZinc));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-magnesium", minMagnesium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-magnesium", maxMagnesium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-manganese", minManganese));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-manganese", maxManganese));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-phosphorus", minPhosphorus));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-phosphorus", maxPhosphorus));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-potassium", minPotassium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-potassium", maxPotassium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-sodium", minSodium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-sodium", maxSodium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-selenium", minSelenium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-selenium", maxSelenium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-copper", minCopper));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-copper", maxCopper));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-calcium", minCalcium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-calcium", maxCalcium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-choline", minCholine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-choline", maxCholine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-cholesterol", minCholesterol));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-cholesterol", maxCholesterol));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-fluoride", minFluoride));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-fluoride", maxFluoride));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-alcohol", minAlcohol));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-alcohol", maxAlcohol));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-caffeine", minCaffeine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-caffeine", maxCaffeine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-saturated-fat", minSaturatedFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-saturated-fat", maxSaturatedFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-a", minVitaminA));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-a", maxVitaminA));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-c", minVitaminC));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-c", maxVitaminC));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-d", minVitaminD));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-d", maxVitaminD));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-e", minVitaminE));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-e", maxVitaminE));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-k", minVitaminK));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-k", maxVitaminK));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b1", minVitaminB1));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b1", maxVitaminB1));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b2", minVitaminB2));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b2", maxVitaminB2));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b3", minVitaminB3));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b3", maxVitaminB3));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b5", minVitaminB5));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b5", maxVitaminB5));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b6", minVitaminB6));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b6", maxVitaminB6));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b12", minVitaminB12));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b12", maxVitaminB12));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort-direction", sortDirection));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "offset", offset));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "number", number));
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SearchRecipesAPI200Response) ApiInvoker.deserialize(localVarResponse, "", SearchRecipesAPI200Response.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Search Recipes API
   * Search and filter thousands of recipes with natural language, e.g. pasta recipes without mushrooms but with truffles. You can filter by ingredients, diet, cuisine, meal type, macro and micro nutrition, intolerances, and much more.
   * @param query The search query.   * @param cuisines The cuisine(s) of the recipes. One or more, comma-separated (will be interpreted as &#39;OR&#39;).   * @param excludeCuisines The cuisine(s) the recipes must not match. One or more, comma-separated (will be interpreted as &#39;AND&#39;).   * @param mealType The type of the recipe, one of: main course,side dish,dessert,appetizer,salad,bread,breakfast,soup,beverage,sauce,drink.   * @param diet The diet the recipes must adhere to. One of the following: paleo,primal,grain-free,pescetarian,lacto vegetarian,ovo vegetarian,vegan,vegetarian.   * @param intolerances A comma-separated list of intolerances. All recipes returned must not contain ingredients that are not suitable for people with the intolerances entered.   * @param equipment The equipment required. Multiple values will be interpreted as &#39;OR&#39;.   * @param includeIngredients A comma-separated list of ingredients that should/must be used in the recipes.   * @param excludeIngredients A comma-separated list of ingredients or ingredient types that the recipes must not contain.   * @param fillIngredients Add information about the ingredients and whether they are used or missing in relation to the query.   * @param addRecipeInformation If set to true, you get more information about the recipes returned.   * @param maxTime The maximum time in minutes it should take to prepare and cook the recipe.   * @param minServings The minimum amount of servings the recipe is for.   * @param maxServings The maximum amount of servings the recipe is for.   * @param minCalories The minimum amount of calories the recipe must have per serving.   * @param maxCalories The maximum amount of calories the recipe can have per serving.   * @param minCarbs The minimum amount of carbohydrates in grams the recipe must have per serving.   * @param maxCarbs The maximum amount of carbohydrates in grams the recipe can have per serving.   * @param minProtein The minimum amount of protein in grams the recipe must have per serving.   * @param maxProtein The maximum amount of protein in grams the recipe can have per serving.   * @param minFat The minimum amount of fat in grams the recipe must have per serving.   * @param maxFat The maximum amount of fat in grams the recipe can have per serving.   * @param minSugar The minimum amount of sugar in grams the recipe must have per serving.   * @param maxSugar The maximum amount of sugar in grams the recipe can have per serving.   * @param minFiber The minimum amount of fiber in grams the recipe must have per serving.   * @param maxFiber The maximum amount of fiber in grams the recipe can have per serving.   * @param minFolate The minimum amount of folate in micrograms the recipe must have per serving.   * @param maxFolate The maximum amount of folate in micrograms the recipe can have per serving.   * @param minFolicAcid The minimum amount of folic acid in micrograms the recipe must have per serving.   * @param maxFolicAcid The maximum amount of folic acid in micrograms the recipe can have per serving.   * @param minIodine The minimum amount of iodine in micrograms the recipe must have per serving.   * @param maxIodine The maximum amount of iodine in micrograms the recipe can have per serving.   * @param minIron The minimum amount of iron in milligrams the recipe must have per serving.   * @param maxIron The maximum amount of iron in milligrams the recipe can have per serving.   * @param minZinc The minimum amount of zinc in milligrams the recipe must have per serving.   * @param maxZinc The maximum amount of zinc in milligrams the recipe can have per serving.   * @param minMagnesium The minimum amount of magnesium in milligrams the recipe must have per serving.   * @param maxMagnesium The maximum amount of magnesium in milligrams the recipe can have per serving.   * @param minManganese The minimum amount of manganese in milligrams the recipe must have per serving.   * @param maxManganese The maximum amount of manganese in milligrams the recipe can have per serving.   * @param minPhosphorus The minimum amount of phosphorus in milligrams the recipe must have per serving.   * @param maxPhosphorus The maximum amount of phosphorus in milligrams the recipe can have per serving.   * @param minPotassium The minimum amount of potassium in milligrams the recipe must have per serving.   * @param maxPotassium The maximum amount of potassium in milligrams the recipe can have per serving.   * @param minSodium The minimum amount of sodium in milligrams the recipe must have per serving.   * @param maxSodium The maximum amount of sodium in milligrams the recipe can have per serving.   * @param minSelenium The minimum amount of selenium in micrograms the recipe must have per serving.   * @param maxSelenium The maximum amount of selenium in micrograms the recipe can have per serving.   * @param minCopper The minimum amount of copper in milligrams the recipe must have per serving.   * @param maxCopper The maximum amount of copper in milligrams the recipe can have per serving.   * @param minCalcium The minimum amount of calcium in milligrams the recipe must have per serving.   * @param maxCalcium The maximum amount of calcium in milligrams the recipe can have per serving.   * @param minCholine The minimum amount of choline in milligrams the recipe must have per serving.   * @param maxCholine The maximum amount of choline in milligrams the recipe can have per serving.   * @param minCholesterol The minimum amount of cholesterol in milligrams the recipe must have per serving.   * @param maxCholesterol The maximum amount of cholesterol in milligrams the recipe can have per serving.   * @param minFluoride The minimum amount of fluoride in milligrams the recipe must have per serving.   * @param maxFluoride The maximum amount of fluoride in milligrams the recipe can have per serving.   * @param minAlcohol The minimum amount of alcohol in grams the recipe must have per serving.   * @param maxAlcohol The maximum amount of alcohol in grams the recipe can have per serving.   * @param minCaffeine The minimum amount of caffeine in milligrams the recipe must have per serving.   * @param maxCaffeine The maximum amount of caffeine in milligrams the recipe can have per serving.   * @param minSaturatedFat The minimum amount of saturated fat in grams the recipe must have per serving.   * @param maxSaturatedFat The maximum amount of saturated fat in grams the recipe can have per serving.   * @param minVitaminA The minimum amount of Vitamin A in IU the recipe must have per serving.   * @param maxVitaminA The maximum amount of Vitamin A in IU the recipe can have per serving.   * @param minVitaminC The minimum amount of Vitamin C in milligrams the recipe must have per serving.   * @param maxVitaminC The maximum amount of Vitamin C in milligrams the recipe can have per serving.   * @param minVitaminD The minimum amount of Vitamin D in micrograms the recipe must have per serving.   * @param maxVitaminD The maximum amount of Vitamin D in micrograms the recipe can have per serving.   * @param minVitaminE The minimum amount of Vitamin E in milligrams the recipe must have per serving.   * @param maxVitaminE The maximum amount of Vitamin E in milligrams the recipe can have per serving.   * @param minVitaminK The minimum amount of Vitamin K in micrograms the recipe must have per serving.   * @param maxVitaminK The maximum amount of Vitamin K in micrograms the recipe can have per serving.   * @param minVitaminB1 The minimum amount of Vitamin B1 in milligrams the recipe must have per serving.   * @param maxVitaminB1 The maximum amount of Vitamin B1 in milligrams the recipe can have per serving.   * @param minVitaminB2 The minimum amount of Vitamin B2 in milligrams the recipe must have per serving.   * @param maxVitaminB2 The maximum amount of Vitamin B2 in milligrams the recipe can have per serving.   * @param minVitaminB3 The minimum amount of Vitamin B3 in milligrams the recipe must have per serving.   * @param maxVitaminB3 The maximum amount of Vitamin B3 in milligrams the recipe can have per serving.   * @param minVitaminB5 The minimum amount of Vitamin B5 in milligrams the recipe must have per serving.   * @param maxVitaminB5 The maximum amount of Vitamin B5 in milligrams the recipe can have per serving.   * @param minVitaminB6 The minimum amount of Vitamin B6 in milligrams the recipe must have per serving.   * @param maxVitaminB6 The maximum amount of Vitamin B6 in milligrams the recipe can have per serving.   * @param minVitaminB12 The minimum amount of Vitamin B12 in milligrams the recipe must have per serving.   * @param maxVitaminB12 The maximum amount of Vitamin B12 in milligrams the recipe can have per serving.   * @param sort The strategy to sort recipes by.   * @param sortDirection Whether to sort ascending or descending (ASC or DESC).   * @param offset The number of recipes to skip, between 0 and 900.   * @param number The number of recipes, between 1 and 100.
  */
  public void searchRecipesAPI (String query, String cuisines, String excludeCuisines, String mealType, String diet, String intolerances, String equipment, String includeIngredients, String excludeIngredients, Boolean fillIngredients, Boolean addRecipeInformation, Integer maxTime, Integer minServings, Integer maxServings, Double minCalories, Double maxCalories, Double minCarbs, Double maxCarbs, Double minProtein, Double maxProtein, Double minFat, Double maxFat, Double minSugar, Double maxSugar, Double minFiber, Double maxFiber, Double minFolate, Double maxFolate, Double minFolicAcid, Double maxFolicAcid, Double minIodine, Double maxIodine, Double minIron, Double maxIron, Double minZinc, Double maxZinc, Double minMagnesium, Double maxMagnesium, Double minManganese, Double maxManganese, Double minPhosphorus, Double maxPhosphorus, Double minPotassium, Double maxPotassium, Double minSodium, Double maxSodium, Double minSelenium, Double maxSelenium, Double minCopper, Double maxCopper, Double minCalcium, Double maxCalcium, Double minCholine, Double maxCholine, Double minCholesterol, Double maxCholesterol, Double minFluoride, Double maxFluoride, Double minAlcohol, Double maxAlcohol, Double minCaffeine, Double maxCaffeine, Double minSaturatedFat, Double maxSaturatedFat, Double minVitaminA, Double maxVitaminA, Double minVitaminC, Double maxVitaminC, Double minVitaminD, Double maxVitaminD, Double minVitaminE, Double maxVitaminE, Double minVitaminK, Double maxVitaminK, Double minVitaminB1, Double maxVitaminB1, Double minVitaminB2, Double maxVitaminB2, Double minVitaminB3, Double maxVitaminB3, Double minVitaminB5, Double maxVitaminB5, Double minVitaminB6, Double maxVitaminB6, Double minVitaminB12, Double maxVitaminB12, String sort, String sortDirection, Integer offset, Integer number, final Response.Listener<SearchRecipesAPI200Response> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;


    // create path and map variables
    String path = "/search-recipes".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();

    queryParams.addAll(ApiInvoker.parameterToPairs("", "query", query));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "cuisines", cuisines));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "exclude-cuisines", excludeCuisines));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "meal-type", mealType));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "diet", diet));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "intolerances", intolerances));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "equipment", equipment));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "include-ingredients", includeIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "exclude-ingredients", excludeIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "fill-ingredients", fillIngredients));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "add-recipe-information", addRecipeInformation));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-time", maxTime));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-servings", minServings));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-servings", maxServings));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-calories", minCalories));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-calories", maxCalories));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-carbs", minCarbs));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-carbs", maxCarbs));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-protein", minProtein));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-protein", maxProtein));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-fat", minFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-fat", maxFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-sugar", minSugar));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-sugar", maxSugar));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-fiber", minFiber));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-fiber", maxFiber));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-folate", minFolate));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-folate", maxFolate));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-folic-acid", minFolicAcid));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-folic-acid", maxFolicAcid));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-iodine", minIodine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-iodine", maxIodine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-iron", minIron));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-iron", maxIron));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-zinc", minZinc));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-zinc", maxZinc));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-magnesium", minMagnesium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-magnesium", maxMagnesium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-manganese", minManganese));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-manganese", maxManganese));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-phosphorus", minPhosphorus));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-phosphorus", maxPhosphorus));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-potassium", minPotassium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-potassium", maxPotassium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-sodium", minSodium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-sodium", maxSodium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-selenium", minSelenium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-selenium", maxSelenium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-copper", minCopper));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-copper", maxCopper));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-calcium", minCalcium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-calcium", maxCalcium));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-choline", minCholine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-choline", maxCholine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-cholesterol", minCholesterol));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-cholesterol", maxCholesterol));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-fluoride", minFluoride));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-fluoride", maxFluoride));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-alcohol", minAlcohol));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-alcohol", maxAlcohol));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-caffeine", minCaffeine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-caffeine", maxCaffeine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-saturated-fat", minSaturatedFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-saturated-fat", maxSaturatedFat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-a", minVitaminA));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-a", maxVitaminA));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-c", minVitaminC));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-c", maxVitaminC));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-d", minVitaminD));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-d", maxVitaminD));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-e", minVitaminE));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-e", maxVitaminE));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-k", minVitaminK));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-k", maxVitaminK));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b1", minVitaminB1));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b1", maxVitaminB1));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b2", minVitaminB2));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b2", maxVitaminB2));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b3", minVitaminB3));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b3", maxVitaminB3));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b5", minVitaminB5));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b5", maxVitaminB5));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b6", minVitaminB6));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b6", maxVitaminB6));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-vitamin-b12", minVitaminB12));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "max-vitamin-b12", maxVitaminB12));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort-direction", sortDirection));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "offset", offset));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "number", number));


    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SearchRecipesAPI200Response) ApiInvoker.deserialize(localVarResponse,  "", SearchRecipesAPI200Response.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Search Restaurants API
  * Search through thousands of restaurants (in North America) by location, cuisine, budget, and more.
   * @param lat The latitude to search around.
   * @param lon The longitude to search around.
   * @param query The search query.
   * @param distance The maximum distance of the restaurant in miles around the given location.
   * @param budget The budget in USD for the meal.
   * @param minRating The minimum rating of the restaurants in range [0,5].
   * @param cuisine The cuisine that the restaurants should support.
   * @param isOpen Whether the restaurants have to be open now.
   * @param page The page of the results.
   * @param sort The sort parameter, one of: cheapest, fastest, rating, distance or relevance.
   * @return SearchRestaurantsAPI200Response
  */
  public SearchRestaurantsAPI200Response searchRestaurantsAPI (Double lat, Double lon, String query, Integer distance, Double budget, Double minRating, String cuisine, Boolean isOpen, Integer page, String sort) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;
    // verify the required parameter 'lat' is set
    if (lat == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'lat' when calling searchRestaurantsAPI",
        new ApiException(400, "Missing the required parameter 'lat' when calling searchRestaurantsAPI"));
    }
    // verify the required parameter 'lon' is set
    if (lon == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'lon' when calling searchRestaurantsAPI",
        new ApiException(400, "Missing the required parameter 'lon' when calling searchRestaurantsAPI"));
    }

    // create path and map variables
    String path = "/search-restaurants";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    queryParams.addAll(ApiInvoker.parameterToPairs("", "query", query));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "lat", lat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "lon", lon));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "distance", distance));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "budget", budget));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-rating", minRating));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "cuisine", cuisine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "is-open", isOpen));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "page", page));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort", sort));
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (SearchRestaurantsAPI200Response) ApiInvoker.deserialize(localVarResponse, "", SearchRestaurantsAPI200Response.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Search Restaurants API
   * Search through thousands of restaurants (in North America) by location, cuisine, budget, and more.
   * @param lat The latitude to search around.   * @param lon The longitude to search around.   * @param query The search query.   * @param distance The maximum distance of the restaurant in miles around the given location.   * @param budget The budget in USD for the meal.   * @param minRating The minimum rating of the restaurants in range [0,5].   * @param cuisine The cuisine that the restaurants should support.   * @param isOpen Whether the restaurants have to be open now.   * @param page The page of the results.   * @param sort The sort parameter, one of: cheapest, fastest, rating, distance or relevance.
  */
  public void searchRestaurantsAPI (Double lat, Double lon, String query, Integer distance, Double budget, Double minRating, String cuisine, Boolean isOpen, Integer page, String sort, final Response.Listener<SearchRestaurantsAPI200Response> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;

    // verify the required parameter 'lat' is set
    if (lat == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'lat' when calling searchRestaurantsAPI",
        new ApiException(400, "Missing the required parameter 'lat' when calling searchRestaurantsAPI"));
    }
    // verify the required parameter 'lon' is set
    if (lon == null) {
      VolleyError error = new VolleyError("Missing the required parameter 'lon' when calling searchRestaurantsAPI",
        new ApiException(400, "Missing the required parameter 'lon' when calling searchRestaurantsAPI"));
    }

    // create path and map variables
    String path = "/search-restaurants".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();

    queryParams.addAll(ApiInvoker.parameterToPairs("", "query", query));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "lat", lat));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "lon", lon));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "distance", distance));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "budget", budget));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "min-rating", minRating));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "cuisine", cuisine));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "is-open", isOpen));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "page", page));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "sort", sort));


    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "apiKey", "headerApiKey" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((SearchRestaurantsAPI200Response) ApiInvoker.deserialize(localVarResponse,  "", SearchRestaurantsAPI200Response.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
}
